import store from "./store";

function add(type, msg, duration) {

  let prom: Promise<boolean>;

  const toast: Toast = {
    type,
    msg,
    time: duration
  }

  if (type === "confirm") {
    prom = new Promise((res, rej) => {
      toast.res = () => {
        store.update(toasts => toasts.filter(t => t !== toast));
        res(true);
      };
      toast.rej = () => {
        store.update(toasts => toasts.filter(t => t !== toast));
        res(false);
      };
    })
  }

  store.update(toasts => [...toasts, toast])

  setTimeout(() => {
    store.update(toasts => toasts.filter(t => t !== toast));
    if (type === "confirm") {
      toast.rej();
    }
  }, duration);

  return prom;

}

export default {
  info: msg => add("info", msg, 3000),
  warn: msg => add("warn", msg, 3000),
  error: msg => add("error", msg, 3000),
  confirm: msg => add("confirm", msg, 10000),
}